#!/bin/sh

echo "pre-install"

DELUGE_FOLDER=/share/Docker/Deluge
DELUGE_CONF=/share/Docker/Deluge/config
DELUGE_SSL=/share/Docker/Deluge/config/ssl
DELUGE_WEB_CONF=/share/Docker/Deluge/config/web.conf

# 1st time install this app, copy default web.conf to avoid random error happened, the container didn't produce defualt web.conf while starting container.
if [ ! -d $DELUGE_FOLDER ]; then
	mkdir -p $DELUGE_FOLDER
fi

# Make sure configuration directory exists
if [ ! -d $DELUGE_CONF ]; then
	mkdir -p $DELUGE_CONF
	mkdir -p $DELUGE_SSL
fi

docker pull lscr.io/linuxserver/deluge:latest


case "$APKG_PKG_STATUS" in
	install)
		;;
	upgrade)
		# If old files exist, rename fist.
		if [ -e $DELUGE_SSL/daemon.pkey ]; then
			mv -f $DELUGE_SSL/daemon.pkey $DELUGE_SSL/daemon.key
			mv -f $DELUGE_SSL/daemon.cert $DELUGE_SSL/daemon.crt
		fi
		
		# If web.conf existed, make sure to update the configuration and ssl certification and key file names here.
		if [ -e $DELUGE_WEB_CONF ]; then
			sed -i 's/\"https\":\ .*\,/'"\"https\": true,"'/g' $DELUGE_WEB_CONF
			sed -i 's/\"cert\":\ \".*\"\,/'"\"cert\": \"ssl\/daemon.crt\","'/g' $DELUGE_WEB_CONF
			sed -i 's/\"pkey\":\ \".*\"\,/'"\"pkey\": \"ssl\/daemon.key\","'/g' $DELUGE_WEB_CONF
		fi
		;;
	*)
		;;
esac

exit 0
