#!/bin/sh

echo "start-stop"

CONTAINER_NAME=Deluge

# Deluge will keep the certificate on /config/ssl folder, need to check if the certificate is updated or not. If yes, need to replace new one.

ADM_SSL_FILE=/usr/builtin/etc/certificate/ssl.crt
ADM_KEY_FILE=/usr/builtin/etc/certificate/ssl.key

DELUGE_SSL_FILE=/share/Docker/Deluge/config/ssl/daemon.crt
DELUGE_KEY_FILE=/share/Docker/Deluge/config/ssl/daemon.key

# Compare the ADM certificate and the Deluge copied one
CERT_DIFF=$(diff -bBq $ADM_SSL_FILE $DELUGE_SSL_FILE | grep differ | awk '{print $5}')

 
case "$1" in
    start)
        echo "Start $CONTAINER_NAME container..."
        docker start $CONTAINER_NAME
        sleep 3 
                        
        ;;
    stop)
    	echo "Stop $CONTAINER_NAME container..."
    	docker stop $CONTAINER_NAME
		
		#While Deluge Container stop, copy the certificate if it's different with ADM certificate. cp -fpu (overwrite, newer one, keep attribute)

		if [ "$CERT_DIFF" == "differ" ]; then
			cp -fpu $ADM_SSL_FILE $DELUGE_SSL_FILE
			cp -fpu $ADM_KEY_FILE $DELUGE_KEY_FILE
		fi
    	sleep 3
        ;;
    reload)
    	echo "Reload $CONTAINER_NAME container..."
    	docker stop  $CONTAINER_NAME
		
		#While Deluge Container stop, copy the certificate if it's different with ADM certificate. cp -fpu (overwrite, newer one, keep attribute)

		if [ "$CERT_DIFF" == "differ" ]; then
			cp -fpu $ADM_SSL_FILE $DELUGE_SSL_FILE
			cp -fpu $ADM_KEY_FILE $DELUGE_KEY_FILE
		fi
		
    	sleep 3
		
    	docker start $CONTAINER_NAME
		sleep 3
        ;;
    *)
        echo "Usage: $0 {start|stop|reload}"
        exit 1
        ;;
esac
exit 0
